/// @file

#if !defined nab_EventListener_h
#define nab_EventListener_h

#include <list>
#include <cassert>

namespace nab
{
		/// A base class for listeners to events of type E. Templated on the event type E.
	template <typename E>
	struct EventListener
	{
		typedef E Event;	///< Convenience definition of the event type.

			/// Process the event that has been raised.
			/// @param e The event.
		virtual void eventRaised(const Event& e) = 0;

	};
}

#endif // nab_Listener_h
